package route

import (
	"kpt-pasture/http/handler/config"

	"github.com/gin-gonic/gin"
)

func ConfigAPI(opts ...func(engine *gin.Engine)) func(s *gin.Engine) {
	return func(s *gin.Engine) {
		for _, opt := range opts {
			opt(s)
		}
		// config API 组
		configRoute := authRouteGroup(s, "/api/v1/config/")
		configRoute.GET("/barn/type/options", config.BarnTypeOptions)
		configRoute.GET("/barn/list/options", config.BarnListOptions)
		configRoute.GET("/breed/status/options", config.BreedStatusOptions)
		configRoute.GET("/cow/kind/options", config.CowKindOptions)
		configRoute.GET("/cow/source/options", config.CowSourceOptions)
		configRoute.GET("/cow/type/options", config.CowTypeOptions)
		configRoute.GET("/cow/transfer/pen/reason/options", config.CowTransferPenReasonOptions)
		configRoute.GET("/bull/frozen/semen/options", config.BullListOptions)
		configRoute.GET("/system/user/options", config.SystemUserOptions)
		configRoute.GET("/system/base/config/options", config.SystemBaseConfigOptions)
		configRoute.GET("/disease/type/options", config.DiseaseTypeOptions)
		configRoute.GET("/disease/options", config.DiseaseOptions)
		configRoute.GET("/prescription/options", config.PrescriptionOptions)
	}
}
