package route

import (
	"kpt-pasture/http/handler/cow"

	"github.com/gin-gonic/gin"
)

func CowAPI(opts ...func(engine *gin.Engine)) func(s *gin.Engine) {
	return func(s *gin.Engine) {
		for _, opt := range opts {
			opt(s)
		}
		// CowAPI API 组  牛只信息
		cowRoute := authRouteGroup(s, "/api/v1/cow/")
		cowRoute.POST("/detail", cow.Detail)
		cowRoute.POST("/list", cow.List)
		cowRoute.POST("/event/list", cow.EventList)
		cowRoute.POST("/behavior/curve", cow.BehaviorCurve)
		cowRoute.POST("/growth/curve", cow.GrowthCurve)

		searchRoute := authRouteGroup(s, "/api/v1/search/")
		searchRoute.POST("/indicators/comparison", cow.IndicatorsComparison)
	}
}
