package route

import (
	"kpt-pasture/http/handler/dashboard"

	"github.com/gin-gonic/gin"
)

func DashboardApi(opts ...func(engine *gin.Engine)) func(s *gin.Engine) {
	return func(s *gin.Engine) {
		for _, opt := range opts {
			opt(s)
		}
		// dashboard API 组
		dashboardRoute := authRouteGroup(s, "/api/v1/dashboard/")
		dashboardRoute.GET("/neck_ring/warning", dashboard.NeckRingWarning)
		dashboardRoute.GET("/focus/indicators/:dimension", dashboard.FocusIndicators)
		dashboardRoute.POST("/focus/indicators/set", dashboard.FocusIndicatorsSet)
		dashboardRoute.GET("/data/warning/list", dashboard.DataWarningList)
		dashboardRoute.POST("/data/warning/set", dashboard.DataWarningSet)
	}
}
