package model

type NeckRingBarChange struct {
	Id             int64  `json:"id"`
	PastureId      int64  `json:"pastureId"`
	NeckRingNumber string `json:"neckRingNumber"`
	HeatDate       string `json:"heatDate"`
	FrameId        int32  `json:"frameId"`
	PenId          int32  `json:"penId"`
	PenName        string `json:"penName"`
	Nb             int32  `json:"nb"`
	ChangeHigh     int32  `json:"changeHigh"`
	ChangeFilter   int32  `json:"changeFilter"`
	CreatedAt      int64  `json:"createdAt"`
	UpdatedAt      int64  `json:"updatedAt"`
}

func (n *NeckRingBarChange) TableName() string {
	return "neck_ring_bar_change"
}

func NewNeckRingBarChange(neckRingNumber, heatDate string, frameId, nb, changeHigh, changeFilter int32, pen *Pen) *NeckRingBarChange {
	return &NeckRingBarChange{
		PastureId:    pen.PastureId,
		HeatDate:     heatDate,
		FrameId:      frameId,
		PenId:        pen.Id,
		PenName:      pen.Name,
		ChangeHigh:   changeHigh,
		ChangeFilter: changeFilter,
		Nb:           nb,
	}
}
