package model

type NeckRingBindLog struct {
	Id                  int64  `json:"id"`
	PastureId           int64  `json:"pastureId"`
	NeckRingNumber      string `json:"neckRingNumber"`
	CowId               int64  `json:"cowId"`
	EarNumber           string `json:"earNumber"`
	OperationStatusName string `json:"operationStatusName"`
	MessageId           int64  `json:"messageId"`
	MessageName         string `json:"messageName"`
	CreatedAt           int64  `json:"createdAt"`
	UpdatedAt           int64  `json:"updatedAt"`
}

func (n *NeckRingBindLog) TableName() string {
	return "neck_ring_bind_log"
}

func NewNeckRingBindLog(pastureId int64, number string, cowInfo *Cow, currUser *SystemUser) *NeckRingBindLog {
	return &NeckRingBindLog{
		PastureId:      pastureId,
		NeckRingNumber: number,
		CowId:          cowInfo.Id,
		EarNumber:      cowInfo.EarNumber,
		MessageId:      currUser.Id,
		MessageName:    currUser.Name,
	}
}
